
#include "stc15f2k60s2.h"
#include "sd.h"
#include "spi.h"
#include "delay.h"



u8  SD_Type=0;//SD 


///////////////////////////////////////////////////////////////////////////////////


//ȴ׼
//ֵ:0,׼;,
u8 SD_WaitReady(void)
{
	u32 t=0;
	do
	{
		if(SPI_SendByte(0XFF)==0XFF)return 0;//OK
		t++;		  	
	}while(t<0XFFFFFF);//ȴ 
	return 1;
}

//ȡѡ,ͷSPI
void SD_DisSelect(void)
{
	SD_CS=1;
 	SPI_SendByte(0xff);//ṩ8ʱ
}

//ѡsd,ҵȴ׼OK
//ֵ:0,ɹ;1,ʧ;
u8 SD_Select(void)
{
	SD_CS=0;
	if(SD_WaitReady()==0)return 0;//ȴɹ
	SD_DisSelect();
	return 1;//ȴʧ
}

//SDһ
//: u8 cmd    
//      u32 arg  
//      u8 crc   crcУֵ	   
//ֵ:SDصӦ															  
u8 SD_SendCmd(u8 cmd, u32 arg, u8 crc)
{
    u8 r1;	
	u8 Retry=0; 

	SD_DisSelect();//ȡϴƬѡ
	if(SD_Select())return 0XFF;//ƬѡʧЧ 


	//
	SD_CS=1;		                                //Ƭѡ																		 
	SPI_SendByte(0xff);
	SPI_SendByte(0xff);	 
	SPI_SendByte(0xff);							    
	SD_CS=0; 

    SPI_SendByte(cmd | 0x40);       //ֱд	2λ̶Ϊ1  
    SPI_SendByte(arg >> 24);		// 2-5ֽ  4ֽ 32λ
    SPI_SendByte(arg >> 16);
    SPI_SendByte(arg >> 8);
    SPI_SendByte(arg);	  
    SPI_SendByte(crc); 
	                                 //ֹͣ
	if(cmd==CMD12)SPI_SendByte(0xff);//Skip a stuff byte when stop reading
    //ȴӦʱ˳
	Retry=0X1F;		   //ѭ32
	do
	{
		r1=SPI_SendByte(0xFF);
	}while((r1&0X80) && Retry--);	 
	//״ֵ̬
    return r1;
}







//ʼSD
u8 SD_Init(void)
{
    u8 r1;      // SDķֵ
    u16 retry;  // гʱ
    u8 buf[4];  
	u8 i;
	
 	SPI_Speed(3);		//õģʽ 

 	for(i=0;i<10;i++)SPI_SendByte(0XFF);//74 ȴSDڲѹʱ	  SPIģʽ

	
	retry=20;
	do
	{
		r1=SD_SendCmd(CMD0,0,0x95);//IDLE״̬ 	 λsd ״̬
	}while((r1!=0X01) && retry--);

	 
 	SD_Type=0;//Ĭ޿
	 
	if(r1==0X01)   //ȡ汾Ϣ
	{	
		if(SD_SendCmd(CMD8,0x1AA,0x87)==1)//SD V2.0	  ͽӿ״̬		                                  
		{							      //ֵΪ1  SDV2.0汾
			for(i=0;i<4;i++)buf[i]=SPI_SendByte(0XFF);	//Get trailing return value of R7 resp
														//ȡֵR7
			if(buf[2]==0X01&&buf[3]==0XAA)//Ƿ֧2.7~3.6V
			{  
				retry=0XFFFE;
				do
				{
					SD_SendCmd(CMD55,0,0X01);	//CMD55
					r1=SD_SendCmd(CMD41,0x40000000,0X01);//CMD41
				}while(r1&&retry--);
				if(retry&&SD_SendCmd(CMD58,0,0X01)==0)//SD2.0汾ʼ
				{	
					for(i=0;i<4;i++)buf[i]=SPI_SendByte(0XFF);//õOCRֵ
					if(buf[0]&0x40)SD_Type=SD_TYPE_V2HC;    //CCS
					else SD_Type=SD_TYPE_V2;  					     						
				}
				else SD_Type=SD_TYPE_ERR;//Ŀ
			}
		}
	
	}

	SD_DisSelect();//ȡƬѡ
	SPI_Speed(0);//	
	if(SD_Type)return 0;	//ûвɼSD汾 
	else if(r1)return r1; 	   
	return 0xaa;//
}




//ָSDһ 512ֽ
//buf:ݻ
//sector:
//ֵ:0,ok;,ʧ. 
u8 SD_read_sector(u32 sector,u8 *buf) 
{ 
    u16 i;
	u8 r1;
	SD_DisSelect();//ȡϴƬѡ
 	if(SD_Select())return 0XFF;//ƬѡʧЧ 

    if(SD_Type!=SD_TYPE_V2HC)sector <<= 9;//תΪֽڵַ


    r1=SD_SendCmd(CMD17,sector,0X01);//
		if(r1==0)//ָͳɹ
		{
		    while(SPI_SendByte(0xff)!=0xfe);
			 for(i=0;i<512;i++) 
			    {
			   //һ 
			    buf[i]=SPI_SendByte(0xff);  
			    }
			 //2αCRCdummy CRC
			  SPI_SendByte(0xff); 
              SPI_SendByte(0xff); 		   
		}


	SD_DisSelect();//ȡƬѡ
	return r1;//

} 


////дSDд512ֽ
////buf:ݻ
////sector:ʼ
////ֵ:0,ok;,ʧ.
//u8 SD_WriteDisk(u8*buf,u32 sector)
//{
//	u8 r1;
//	u16 t;
//    sector *= 512;//תΪֽڵַ
//
//	r1=SD_SendCmd(CMD24,sector,0X01);//
//	if(r1==0)//ָͳɹ
//	{
//
//     if(SD_WaitReady()){SD_DisSelect();return 1;}//ȴ׼ʧЧ
//	 SPI_SendByte(0xFE); //
//
//	 for(t=0;t<512;t++)SPI_SendByte(buf[t]);//дֽ
//	 SPI_SendByte(0xFF);    //crc
//	 SPI_SendByte(0xFF);
//	 t=SPI_SendByte(0xFF);  //Ӧ
//	 if((t&0x1F)!=0x05)r1=2;//Ӧ									  					    
//	 	 	   
//	}
//
//
//	SD_DisSelect();//ȡƬѡ
//	return r1;
//}



//ָдSDһ 512ֽ
//buf:ݻ
//sector:ʼ
//cnt:
//ֵ:0,ok;,ʧ.
//u8 SD_write_sector(u32 sector,u8*buf)
//{
//	u8 r1;
//	u16 t;
//	u32 m=0;
//	if(SD_Type!=SD_TYPE_V2HC)sector *= 512;//תΪֽڵַ
//
//	 r1=SD_SendCmd(CMD24,sector,0X01);//
//		if(r1==0)//ָͳɹ
//		{
//			//r1=SD_SendBlock(buf,0xFE);//д512ֽ	 
//			 //ȴ׼	
//	          do
//	          {
//		        if(SPI_SendByte(0XFF)==0XFF)break;//OK
//		          m++;		  	
//	           }while(m<0XFFFFFF);//ȴ 
//
//	          SPI_SendByte(0XFE);
//			  
//				for(t=0;t<512;t++)SPI_SendByte(buf[t]);//ٶ,ٺʱ
//			    SPI_SendByte(0xFF);//crc
//			    SPI_SendByte(0xFF);
//				t=SPI_SendByte(0xFF);//Ӧ
//				if((t&0x1F)!=0x05)return 2;//Ӧ									  					    
//		}
//	SD_DisSelect();//ȡƬѡ
//	return 0;  //дɹ
//
//					
//}



////ַָ ȡ ָֽ
////addr:ַ
////buf:ݻ
////BytesҪȡֽ
////ֵ:0,ok;,ʧ.   
//u8 SD_read_Byte(u32 addr,u8 *buf,u32 Bytes) 
//{ 
//    u16 i;
//    u8 temp=0,retry;
//
//    // 16ÿ鳤 
//    SD_SendCmd(16,Bytes,0xff); 
//
//    retry = 0;
//
//    do
//    {
//    // дCMD17 	ȡ
//    temp=SD_SendCmd(17,addr,0xff);
//    retry++;
//    }
//		
//	while((temp!=0x00) && (retry < TRY_TIME)); 
//
//	
//    if (retry >= TRY_TIME) 
//    {
//    return READ_BLOCK_ERROR; 
//    }
//
//    // 0xfeͷ  
//    while(SPI_SendByte(0xff)!=0xfe);
//
//     for(i=0;i<Bytes;i++) 
//    {
//
//        //ָ ֽݵbuf
//        buf[i] = SPI_SendByte(0xff);  
//    }
//
//   //2αCRCdummy CRC
//    SPI_SendByte(0xff); 
//    SPI_SendByte(0xff);  
//
//
//    //* 16ָ鳤 Ϊ512ֽ
//    SD_SendCmd(16,512,0xff);
//	SD_DisSelect();//ȡƬѡ
//    
//    return 0; 
//
//} 


